from machine import Pin, I2C
from gpio_lcd import GpioLcd
import time

push1 = Pin(10, Pin.IN, Pin.PULL_UP)
std1 = 1

i2c = I2C(1,scl=Pin(15), sda=Pin(14), freq=400000)
lcd = GpioLcd(rs_pin=Pin(20),
              enable_pin=Pin(21),
              d4_pin=Pin(22),
              d5_pin=Pin(26),
              d6_pin=Pin(27),
              d7_pin=Pin(28),
              num_lines=2, num_columns=16)
lcd.move_to(1,0)
lcd.putstr("I2C_SCANNER")
time.sleep(2)

while True:
              
    if push1.value() == 0:
        time.sleep_ms(5)
        if push1.value() == 0:
            std1 = 0
            time.sleep_ms(5)
    if push1.value() == 1 and std1 == 0:
       lcd.clear()  
       devices = i2c.scan()

       if len(devices) == 0:
         lcd.move_to(1,0)
         lcd.putstr("No Device")
       else:   
        lcd.move_to(1,0)
        strg ='Devices:  '+ str(len(devices)) 
        lcd.putstr(strg)
        
       for device in devices:  
        lcd.move_to(1,1)
        strg ='Address:'+ str(device) +" " + str(hex(device)) 
        lcd.putstr(strg)
    std1 = 1